SystemOrganization addCategory: #ConfigurationOfWebStore!

Object subclass: #ConfigurationOfWebStore
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfWebStore'!

!ConfigurationOfWebStore class methodsFor: 'development support' stamp: 'StuartHerring 10/28/2012 13:44'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfWebStore class methodsFor: 'private' stamp: 'StuartHerring 10/28/2012 13:44'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfWebStore class methodsFor: 'private' stamp: 'StuartHerring 10/28/2012 13:44'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfWebStore class methodsFor: 'private' stamp: 'StuartHerring 10/28/2012 13:44'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfWebStore class methodsFor: 'metacello tool support' stamp: 'StuartHerring 10/28/2012 13:44'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfWebStore class methodsFor: 'loading' stamp: 'StuartHerring 10/28/2012 13:44'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfWebStore class methodsFor: 'loading' stamp: 'StuartHerring 10/28/2012 13:44'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfWebStore class methodsFor: 'loading' stamp: 'StuartHerring 10/28/2012 13:44'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfWebStore class methodsFor: 'accessing' stamp: 'StuartHerring 10/28/2012 13:44'!
project

	^self new project! !

!ConfigurationOfWebStore class methodsFor: 'development support' stamp: 'StuartHerring 10/28/2012 13:44'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfWebStore methodsFor: 'baselines' stamp: 'StuartHerring 1/25/2013 22:41'!
baseline20: spec
	<version: '2.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/WebStore'.
		spec 
			project: 'Seaside28' with: [
				spec
					className: 'ConfigurationOfSeaside28';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Seaside2' 'Scriptaculous') ];
			project: 'Seaside28-All' with: [
				spec
					className: 'ConfigurationOfSeaside28';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Magma' with: [
				spec
					className: 'ConfigurationOfMagmaPharo';
					versionString: '1.4';
					repository: 'http://ss3.gemstone.com/ss/MagmaPharo';
					loads: 'Server' ];
			project: 'Ston' with: [
				spec
					className: 'ConfigurationOfSton';
					versionString: #stable;
					repository: 'http://squeaksource.com/MetacelloRepository'];
			project: 'XMLSupport' with: [
				spec
					className: 'ConfigurationOfXMLSupport';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
				
		spec package: 'Magma seaside' with: [
			spec repository: 'http://www.squeaksource.com/Magma' ].

		spec package: 'Pharo-Future' with: [
				spec repository: 'http://stuartherring.net/mc/misc'].

		spec package: 'Magma-Ston-Patch' with: [
				spec requires: #('Magma' 'Ston').
				spec repository: 'http://stuartherring.net/mc/misc'].
		
		spec package: 'SeasideTesting' with: [
				spec repository: 'http://stuartherring.net/mc/misc' ].
			
		spec package: 'SMock' with: [
				spec repository: 'http://stuartherring.net/mc/misc'].
			
		spec 
			package: 'WebStore' with: [
				spec requires: #('Seaside28' 'Magma' 'XMLSupport' 'Magma seaside' 'Pharo-Future' 'Ston' 'Magma-Ston-Patch'). ];
			package: 'WebStoreTests' with: [
				spec requires: #('WebStore' 'SeasideTesting' 'SMock'). ].
		spec 
			group: 'default' with: #('Core' );
			group: 'Core' with: #('WebStore' );
			group: 'Tests' with: #('WebStoreTests' );
			group: 'Development' with: #('Core' 'Tests' 'Seaside28-All') 
		].
! !

!ConfigurationOfWebStore methodsFor: 'symbolic versions' stamp: 'StuartHerring 11/10/2012 17:49'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '2.0'.
! !

!ConfigurationOfWebStore methodsFor: 'accessing' stamp: 'StuartHerring 10/28/2012 13:44'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfWebStore methodsFor: 'versions' stamp: 'StuartHerring 1/30/2013 19:53'!
version20: spec
	<version: '2.0' imports: #('2.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'Start of 2.0
Added dependency on Pharo-Futures, and ported connection pool to use them
Improved the handling of return session when called twice on the same session
WS-69.
		Remove the pools and instead create a session on demand
WS-69.
		Ensure we get the configuration from the correct place
WS-72
		
Use https instead of http
General improvements and fixes to make the tests pass
Updated magma version
Increased preview and medium sizes and added tool to regenerate images
WS-68
Added import and export support based on STON
WS-71
		
added basic Gallery model, and a glass for populating it from a Gallery 3 instance with the REST module
WS-71
		
added a version of the imageViewer component that uses the gallery as an image source'.
		spec author: 'StuartHerring'.
		spec timestamp: '1/30/2013 19:53'.
		spec 
			project: 'Seaside28' with: '2.8.5';
			project: 'Seaside28-All' with: '2.8.5';
			project: 'Magma' with: '1.4';
			project: 'XMLSupport' with: #'stable'.
		spec 
			package: 'Magma-Ston-Patch' with: 'Magma-Ston-Patch-StuartHerring.1';
			package: 'Magma seaside' with: 'Magma seaside-cmm.5';
			package: 'SeasideTesting' with: 'SeasideTesting-StuartHerring.27';
			package: 'SMock' with: 'SMock-StuartHerring.11';
			package: 'Pharo-Future' with: 'Pharo-Future-StuartHerring.6';
			package: 'WebStore' with: 'WebStore-StuartHerring.170';
			package: 'WebStoreTests' with: 'WebStoreTests-StuartHerring.44'. ].
! !
